const tabContextMenu = require("tab-context-menu");
const {Cc,Ci,Cu} = require("chrome");
const myTabFunc=require("myTabFunc");
const tabUtils=require('tabs/utils');
const windowUtils=require('window/utils');
const kitWindows=require("windows");
const kitTabs=require("tabs");
const tabTracker=require("tabTracker");
const { Hotkey } = require("sdk/hotkeys");

exports.main = function() {
    tabContextMenu.Item({
        label: "Duplicate(Ctrl+Alt+,)",
		onClick: function(tab) {
			myTabFunc.duplicate(tab);
		}
	});
    tabContextMenu.Item({
		label: "Placehold(Ctrl+Alt+.)",
        onClick: function(tab) {
            myTabFunc.placeHoldAndKill(tab);
		}
	});
    tabContextMenu.Item({
        label: "UnzipPlacehold(Ctrl+Alt+Shift+.)",
        onClick: function(tab) {
            myTabFunc.unzip(tab);
        }
	});
    tabContextMenu.Item({
        label: "Freeze(Ctrl+Alt+K)",
        onClick: function(tab) {
            myTabFunc.freeze(tab);
    	}
	});
    tabContextMenu.Item({
        label: "Close(Ctrl+Alt+Shift+K)",
        onClick: function(tab) {
            myTabFunc.kill(tab);
    	}
	});
};

var placeHoldHotKey = Hotkey({
  combo: "accel-ctrl-alt-.",
  onPress: function() {
    myTabFunc.placeHoldAndKill(tabUtils.getActiveTab(windowUtils.getMostRecentBrowserWindow()));
    //myTabFunc.kill(tabUtils.getActiveTab(windowUtils.getMostRecentBrowserWindow()));
  }
});
var placeHoldUnzipHotKey = Hotkey({
  combo: "accel-ctrl-alt-shift-.",
  onPress: function() {
    myTabFunc.unzip(tabUtils.getActiveTab(windowUtils.getMostRecentBrowserWindow()))
  }
});
var freezeHotKey = Hotkey({
  combo: "accel-ctrl-alt-k",
  onPress: function() {
    myTabFunc.freeze(tabUtils.getActiveTab(windowUtils.getMostRecentBrowserWindow()));
  }
});
var freezeHotKey = Hotkey({
  combo: "accel-ctrl-alt-shift-k",
  onPress: function() {
    myTabFunc.kill(tabUtils.getActiveTab(windowUtils.getMostRecentBrowserWindow()));
  }
});
var duplicateHoldHotKey = Hotkey({
  combo: "accel-ctrl-alt-,",
  onPress: function() {
    myTabFunc.duplicate(tabUtils.getActiveTab(windowUtils.getMostRecentBrowserWindow()));
  }
});
var allSetHotKey=Hotkey({
  combo: "accel-ctrl-alt-;",
  onPress: function() {
    myTabFunc.allSet();
  }
});
