const {Cc,Ci} = require("chrome");
const SessionStore =Cc["@mozilla.org/browser/sessionstore;1"].getService(Ci.nsISessionStore);
var kitWidget=require("widget");
var kitClipboard = require("clipboard");
var kitTabs=require("tabs");
var kitWindows=require("windows");
var kitPageWorker=require("page-worker");
var resource=require("self").data.url;
const tabUtils=require('tabs/utils');
const windowUtils=require('window/utils');
const timers=require("timers");
const tabTracker=require("tabTracker");
const base64 = require("sdk/base64");
 

function freeze(tab) {
  if(tab.hasAttribute("restoring")){
    console.log("restore:"+tab.getAttribute("restoring"));
    return;
  }
  if(tab.hasAttribute("pending")){
      console.log("pending! "+tab.label);
  }
  if(tab.pinned){
      console.log("pinnned! "+tab.label);
      return;
  }
  if(tab.selected){
      console.log("selected! "+tab.label);
      return;
  }
  console.log("found! "+tab.label);
  
  browser = tab.linkedBrowser;
  if (browser.__SS_restoreState)
  return;
  
  let state = SessionStore.getTabState(tab),
      shistory = browser.sessionHistory,
      icon = tab.getAttribute("image");

  browser.addEventListener("load", function onload(){
    this.removeEventListener("load", onload, true);
    if (shistory.count > 1)
      shistory.PurgeHistory(shistory.count -1);

    tab.ownerDocument.defaultView.setTimeout(function(){
      tab.setAttribute("image", icon);
    }, 0);
    SessionStore.setTabState(tab, state);
    timers.setTimeout(
        function (){tab.setAttribute("restoring",true);
        tab.setAttribute("pending",true);
        tab.removeAttribute("unread");
        });
    console.log("unko");
  }, true);
  browser.loadURI("about:blank");
}
function dataURI(content,mimetype){
    mimetype=mimetype||"text/html";
    var output="data:"+mimetype+";base64,"+content;
    return output;
}

const divider="p";
const divideTag=divider;
const dividePat=/\<\/p\>/g;

function placeHold(tabs){
    var html="<html><head><title>placeHolder</title></head><body>";
    for each(tab in tabs){
        html+="<"+divideTag+">"+tabUtils.getURI(tab)+"<h>"+SessionStore.getTabState(tab)+"</h>"+"</"+divideTag+">";
    }
    html+="</body>";
    var encodedData = base64.encode(html, "utf-8");
    kitTabs.open(dataURI(encodedData));
}
function duplicate(tab){
    let ntab=tabUtils.openTab(tabUtils.getOwnerWindow(tab),null);
    SessionStore.setTabState(ntab,SessionStore.getTabState(tab));
}
function getTargetTabs(curTab){
    var ret=[];
    var pos=0;
    for each(cand in tabUtils.getTabs()){
        if(tabTracker.getAttrRemove(cand)){
            ret[pos]=cand;
            ++pos;
        }
    }
    return ret.length>0?ret:[curTab];
}
function freezeO(curTab){
    var tg=getTargetTabs(curTab);
    for each(target in tg){
        freeze(target);
    }
}
function placeHoldO(curTab){
    var tg=getTargetTabs(curTab);
    placeHold(tg);
}
function kill(curTab){
    var tg=getTargetTabs(curTab);
    for each(target in tg){
        tabUtils.closeTab(target);
    }
}
function duplicateO(curTab){
    var tg=getTargetTabs(curTab);
    for each(target in tg){
        duplicate(target);
    }
}
function unzip(tab){
    tmp=tabUtils.getURI(tab);
    if(tmp.indexOf("text/html")==-1){
        return;
    }
    URI=base64.decode(tmp.split(";base64,")[1],"utf-8");
    var ll=URI.replace(dividePat,"").replace("</body>","").split("<"+divideTag+">");
    for(var pp=1;pp<ll.length;++pp){
        var tmp=ll[pp].replace("</h>","").split("<h>");
        var targetTab=tabUtils.openTab(tabUtils.getOwnerWindow(tab),"about:blank");
        SessionStore.setTabState(targetTab,tmp[1]);
        console.log(ll[pp]);
    }
    tabUtils.closeTab(tab);
}
function isSetTabSelection(tab){
    return tab.hasAttribute("multiselected");
}
function setTabSelection(tab){
    if(tab.hasAttribute("multiselected")){
        //console.log("sanity");
        return;
    }
    tab.setAttribute("multiselected",true);
    tab.setAttribute("style_bak",tab.getAttribute("style"));
    tab.setAttribute("style",tab.getAttribute("style")+";  font-weight: bold; background-color:#ffcc00 !important;");
}
function unsetTabSelection(tab){
    if(!tab.hasAttribute("multiselected")){
        return;
    }
    tab.removeAttribute("multiselected");
    tab.setAttribute("style",tab.getAttribute("style_bak"));
    tab.removeAttribute("style_bak");
}
function allSet(){
    var tabs=tabUtils.getTabs(windowUtils.getMostRecentBrowserWindow());
    var al=true;
    for(var pp=0;pp<tabs.length;++pp){
        al&=isSetTabSelection(tabs[pp]);
        setTabSelection(tabs[pp]);
    }
    if(al){
        for(var pp=0;pp<tabs.length;++pp){
            unsetTabSelection(tabs[pp]);
        }
    }
}
function placeHoldAndKill(curTab){
    var tg=getTargetTabs(curTab);
    placeHold(tg);
    for each(target in tg){
        tabUtils.closeTab(target);
    }
}

exports.freeze=freezeO;
exports.placeHold=placeHoldO;
exports.placeHoldAndKill=placeHoldAndKill;
exports.duplicate=duplicateO;
exports.unzip=unzip;
exports.kill=kill;

exports.allSet=allSet;
exports.setTabSelection=setTabSelection;
exports.unsetTabSelection=unsetTabSelection;
