const tabBrowser = require("sdk/deprecated/tab-browser");
const tabUtils=require('tabs/utils');
const winUtils = require("window-utils");
const myTabFunc=require("myTabFunc");
var prev=null;

function toggleTabSelection(tab){
    if(!tab.hasAttribute("multiselected")){
        myTabFunc.setTabSelection(tab);
    }else{
        myTabFunc.unsetTabSelection(tab);
    }
}

function min(a,b){
    return a>b?b:a;
}
function max(a,b){
    return a<b?b:a;
}
function getTabPosition(tab){
    return tab._tPos;
}
function allSet(event){
    /*var tabs=tabUtils.getTabs(tabUtils.getOwnerWindow(event.explicitOriginalTarget));
    for(var pp=0;pp<tabs.length;++pp){
        myTabFunc.setTabSelection(tabs[pp]);
    }*/
    myTabFunc.allSet();
}
function tabClickEventListener(event){
    if(event.button!=0)return;
    console.log("click!!!");
    var tabs = require("sdk/tabs");
    if(event.ctrlKey){
        toggleTabSelection(event.explicitOriginalTarget);
        prev=event.explicitOriginalTarget;
    }else if(event.shiftKey){
        if(prev==null){
            toggleTabSelection(event.explicitOriginalTarget);
            prev=event.explicitOriginalTarget;
            return;
        }
        var start=min(getTabPosition(prev),getTabPosition(event.explicitOriginalTarget));
        var end=max(getTabPosition(prev),getTabPosition(event.explicitOriginalTarget));
        console.log("change state:"+start+" - "+end);
        var tabs=tabUtils.getTabs(tabUtils.getOwnerWindow(event.explicitOriginalTarget));
        var sanity=(tabs[getTabPosition(prev)]==prev) &&
        (tabs[getTabPosition(event.explicitOriginalTarget)]==event.explicitOriginalTarget);
        if(!sanity){
            console.log("tab index sanity");
            return;
        }
        if(start==end){
            allSet(event);
        }else{
            for(var pp=start;pp<=end;++pp){
                myTabFunc.setTabSelection(tabs[pp]);
            }
        }
    }else{
        //prev=event.explicitOriginalTarget;
        prev=null;
        allClear();
        event.explicitOriginalTarget.parentNode._selectNewTab_bak(event.explicitOriginalTarget);
    }
}
function allClear(){
    for each(tab in tabUtils.getTabs()){
        myTabFunc.unsetTabSelection(tab);
    }
}
var targetEvent="mousedown";
let tracker = {
  onTrack: function(tab) {
    tab.addEventListener(targetEvent,tabClickEventListener,false);
  },
  onUntrack: function(tab) {
    if(tab==prev){
        prev=null;
    }
    tab.removeEventListener(targetEvent,tabClickEventListener);
  }
};
tabBrowser.TabTracker(tracker);


var winTrackerDelegate = {
    init: function() {
		var winTracker = new winUtils.WindowTracker(this);
		require("unload").ensure(winTracker);
	},
	onTrack: function(win) {
		{
            console.log(win);
            if (win.location.href != "chrome://browser/content/browser.xul")
                return;
            var elt = win.document.getElementById("tabbrowser-tabs");
            var tmpNT=elt._selectNewTab;
            elt._selectNewTab_bak=tmpNT;
            elt._selectNewTab=function(a,b,c){
                var pos=arguments.callee.caller.toString().indexOf("function onxblmousedown(event)");
                if(pos==0){
                    console.log("black list!");
                    return;
                }else{
                    console.log("safe!");
                    elt._selectNewTab_bak(a,b,c);
                }
            };
            console.log(elt._selectNewTab);
        }
	},
	onUntrack: function(win) {
		{
            if (win.location.href != "chrome://browser/content/browser.xul")
                return;
            var elt = win.document.getElementById("tabbrowser-tabs");
            var tmpNT=elt._selectNewTab;
            elt._selectNewTab=elt._selectNewTab_bak;
        }
	},
};

winTrackerDelegate.init();


exports.getAttrRemove=function(tab){
    var ret=tab.hasAttribute("multiselected");
    myTabFunc.unsetTabSelection(tab);
    return ret;
}
